| Disk ARchive 2.5.10 Full featured and portable backup and archiving tool

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | List of all members
libdar::fichier_global Class Referenceabstract
Private

abstraction of filesystem files for entrepot More...

`#include <fichier_global.hpp>`

Inherits libdar::generic_file, libdar::thread_cancellation, and libdar::mem_ui.

Inherited by libdar::fichier_local, libdar::generic_to_global_file, and libdar::hash_fichier.

## Public Types
enum | advise { advise_normal, advise_sequential, advise_random, advise_noreuse, advise_willneed, advise_dontneed }
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward, skip_forward }

## Public Member Functions
| fichier_global (const user_interaction &dialog, gf_mode mode)
| fichier_global (const fichier_global &ref)
virtual void | change_ownership (const std::string &user, const std::string &group)=0
| set the ownership of the file
virtual void | change_permission (U_I perm)=0
| change the permission of the file
virtual infinint | get_size () const =0
| return the size of the file
virtual void | fadvise (advise adv) const =0
| set posix_fadvise for the whole file
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
virtual | ~generic_file () throw (Ebug)
| virtual destructor, this let inherited destructor to be called even from a generic_file pointer to an inherited class
void | terminate () const
| destructor-like call, except that it is allowed to throw exceptions
const generic_file & | operator= (const generic_file &ref)
| assignment operator
gf_mode | get_mode () const
| retreive the openning mode for this object
virtual void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
U_I | read (char *a, U_I size)
| read data from the generic_file More...
void | write (const char *a, U_I size)
| write data to the generic_file More...
void | write (const std::string &arg)
| write a string to the generic_file More...
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual bool | skippable (skippability direction, const infinint &amount)=0
virtual bool | skip (const infinint &pos)=0
virtual bool | skip_to_eof ()=0
| skip to the end of file
virtual bool | skip_relative (S_I x)=0
| skip relatively to the current position
virtual infinint | get_position () const =0
| get the current read/write position
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data More...
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument More...
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data More...
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset More...
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::on_pool
void * | operator new (size_t n_byte)
void * | operator new (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new[] (size_t n_byte)
void * | operator new[] (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new (size_t n_byte, memory_pool *p)
void * | operator new[] (size_t n_byte, memory_pool *p)
void | operator delete (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated object
void | operator delete[] (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated objects
void | operator delete (void *ptr)
| this is the usual delete operator, modified to handle allocated objects allocated on a memory pool or not
void | operator delete[] (void *ptr)
| this is the usual delete[] operator, modified to handle allocated objects allocated on a memory pool or not
Public Member Functions inherited from libdar::thread_cancellation
| thread_cancellation ()
| the constructor
virtual | ~thread_cancellation () throw (Ebug)
| the destructor
void | check_self_cancellation () const
| Checkpoint test : whether the current libdar call must abort or not. More...
void | block_delayed_cancellation (bool mode)
Public Member Functions inherited from libdar::mem_ui
| mem_ui (const user_interaction &dialog)
| constructor More...
| mem_ui (user_interaction *dialog)
| mem_ui (const mem_ui &ref)
| the copy constructor More...
virtual | ~mem_ui () throw (Ebug)
| destructor More...
const mem_ui & | operator= (const mem_ui &ref)
| assignement operator More...

## Protected Member Functions
virtual U_I | fichier_global_inherited_write (const char *a, U_I size)=0
virtual bool | fichier_global_inherited_read (char *a, U_I size, U_I &read, std::string &message)=0
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
virtual void | inherited_read_ahead (const infinint &amount)=0
virtual void | inherited_sync_write ()=0
| write down any pending data More...
virtual void | inherited_flush_read ()=0
virtual void | inherited_terminate ()=0
| destructor-like call, except that it is allowed to throw exceptions More...
bool | is_terminated () const
Protected Member Functions inherited from libdar::on_pool
memory_pool * | get_pool () const
template<class T >
void | meta_new (T *&ptr, size_t num)
template<class T >
void | meta_delete (T *ptr)
Protected Member Functions inherited from libdar::mem_ui
user_interaction & | get_ui () const
| get access to the user_interaction cloned object More...

## Additional Inherited Members
Static Public Member Functions inherited from libdar::thread_cancellation
static U_I | count ()
| method for debugging/control purposes

## Detailed Description

abstraction of filesystem files for entrepot

Definition at line 60 of file fichier_global.hpp.

## Constructor & Destructor Documentation

libdar::fichier_global::fichier_global | ( | const user_interaction & | dialog,
|  | gf_mode | mode
| ) |  |
| inline

constructors

Note
  some well defined error case must generate an Esystem exception, other by Erange or more appropriated Egeneric exceptions to known what type of error must be handled by Esystem object, see the Esystem::io_error enum

Definition at line 77 of file fichier_global.hpp.

## Member Function Documentation

virtual bool libdar::fichier_global::fichier_global_inherited_read | ( | char * | a,
|  | U_I | size,
|  | U_I & | read,
|  | std::string & | message
| ) |  |
| protected pure virtual

replaces generic_file::inherited_read() method, to allow the return of partial reading

a partial reading is signaled by the inherited class by returning false

Parameters

  [in] | a | points to the area where to store read data
  [in] | size | is the available place to store data
  [out] | read | is the total amount of data read so far
  [out] | message | is the request to send to the user upon partial reading

Returns
  true if the reading is full (either read the maximum allowed data or reached end of file) false is returned if a user interaction can let the reading go further the message to display to the user asking him for action. He will also be proposed to abort the current operation.

Implemented in libdar::fichier_local.

virtual U_I libdar::fichier_global::fichier_global_inherited_write | ( | const char * | a,
|  | U_I | size
| ) |  |
| protected pure virtual

replaces generic_file::inherited_write() method, to allow the return of partial writings

a partial writing is allowed when no space is available for writing this let global_ficher interact with the user asking whether it can make place or if (s)he wants to abord

Parameters

  [in] | a | points to the start of the area of data to write
  [in] | size | is the size in byte of the data to write

Returns
  the amount of byte wrote. If the returned value is less than size, this is a partial write, and is assumed that free storage space is missing to complete the operation

Implemented in libdar::fichier_local.

The documentation for this class was generated from the following file:

- fichier_global.hpp